> ## Documentation Index
> Fetch the complete documentation index at: https://docs.tracecat.com/llms.txt
> Use this file to discover all available pages before exploring further.

# Update Integration

> Update OAuth client credentials for the specified provider integration.



## OpenAPI

````yaml https://platform.tracecat.com/api/openapi.json put /workspaces/{workspace_id}/integrations/{provider_id}
openapi: 3.1.0
info:
  title: Tracecat API
  summary: Tracecat API
  description: The open source AI automation platform for security teams and agents.
  termsOfService: >-
    https://docs.google.com/document/d/e/2PACX-1vQvDe3SoVAPoQc51MgfGCP71IqFYX_rMVEde8zC4qmBCec5f8PLKQRdxa6tsUABT8gWAR9J-EVs2CrQ/pub
  contact:
    name: Tracecat Founders
    email: founders@tracecat.com
  license:
    name: AGPL-3.0
    url: https://www.gnu.org/licenses/agpl-3.0.html
  version: '1'
servers:
  - url: /api
security: []
tags:
  - name: public
    description: Public facing endpoints
  - name: workflows
    description: Workflow management
  - name: actions
    description: Action management
  - name: triggers
    description: Workflow triggers
  - name: secrets
    description: Secret management
  - name: variables
    description: Workspace variable management
paths:
  /workspaces/{workspace_id}/integrations/{provider_id}:
    put:
      tags:
        - integrations
      summary: Update Integration
      description: Update OAuth client credentials for the specified provider integration.
      operationId: integrations-update_integration
      parameters:
        - name: workspace_id
          in: path
          required: true
          schema:
            type: string
            format: uuid
            title: Workspace Id
        - name: provider_id
          in: path
          required: true
          schema:
            type: string
            title: Provider Id
        - name: grant_type
          in: query
          required: false
          schema:
            $ref: '#/components/schemas/OAuthGrantType'
            default: authorization_code
      requestBody:
        required: true
        content:
          application/json:
            schema:
              $ref: '#/components/schemas/IntegrationUpdate'
      responses:
        '204':
          description: Successful Response
        '422':
          description: Validation Error
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/HTTPValidationError'
      security:
        - APIKeyCookie: []
        - ServiceAccountApiKeyBearer: []
components:
  schemas:
    OAuthGrantType:
      type: string
      enum:
        - authorization_code
        - client_credentials
      title: OAuthGrantType
      description: Grant type for OAuth 2.0.
    IntegrationUpdate:
      properties:
        grant_type:
          $ref: '#/components/schemas/OAuthGrantType'
          description: OAuth grant type for this integration
        client_id:
          anyOf:
            - type: string
              minLength: 1
            - type: 'null'
          title: Client Id
          description: OAuth client ID for the provider
        client_secret:
          anyOf:
            - type: string
              minLength: 1
              format: password
              writeOnly: true
            - type: 'null'
          title: Client Secret
          description: OAuth client secret for the provider
        authorization_endpoint:
          anyOf:
            - type: string
              minLength: 8
            - type: 'null'
          title: Authorization Endpoint
          description: >-
            OAuth authorization endpoint URL. Overrides provider defaults when
            set.
        token_endpoint:
          anyOf:
            - type: string
              minLength: 8
            - type: 'null'
          title: Token Endpoint
          description: OAuth token endpoint URL. Overrides provider defaults when set.
        scopes:
          anyOf:
            - items:
                type: string
              type: array
            - type: 'null'
          title: Scopes
          description: OAuth scopes to request for this integration
      type: object
      required:
        - grant_type
      title: IntegrationUpdate
      description: Request model for updating an integration.
    HTTPValidationError:
      properties:
        detail:
          items:
            $ref: '#/components/schemas/ValidationError'
          type: array
          title: Detail
      type: object
      title: HTTPValidationError
    ValidationError:
      properties:
        loc:
          items:
            anyOf:
              - type: string
              - type: integer
          type: array
          title: Location
        msg:
          type: string
          title: Message
        type:
          type: string
          title: Error Type
        input:
          title: Input
        ctx:
          type: object
          title: Context
      type: object
      required:
        - loc
        - msg
        - type
      title: ValidationError
  securitySchemes:
    APIKeyCookie:
      type: apiKey
      in: cookie
      name: fastapiusersauth
    ServiceAccountApiKeyBearer:
      type: http
      description: Tracecat service account API key.
      scheme: bearer

````